<?php

namespace Teknisa\PED\Modules\Expedicao\Services;

use Teknisa\PED\Modules\Expedicao\Factories\exp0800ComissaoVendedorPeriodoFactory;
use \Teknisa\Libs\Util\DateUtil;

class exp0800ComissaoVendedorPeriodoService {
    public function __construct(exp0800ComissaoVendedorPeriodoFactory $factory, $newCode, $environment) {
        #initializes default service
        $this->factory = $factory;
        $this->newCode = $newCode;
        $this->environment = $environment;
    }
    
    // Busca rows para inserção na tabela mapacomrec;
    public function getRowsToSaveNota($row) {
        // Busca notas dos 2 periodos anteriores que não foram computadas
        $notasMapasAnteriores = array();
   
        $mapasAnteriores = $this->factory->getMapasAnteriores($row);
        if($mapasAnteriores) {
            foreach ($mapasAnteriores as $mapa) {
                $rowMes['NRORG']             = $row['NRORG'];
                $rowMes['VENDEDOR']          = $row['VENDEDOR'];
                $rowMes['CDFILIAL']          = $row['CDFILIAL'];
                $rowMes['INICIAL']           = DateUtil::getDataDeString($mapa['DTINIPERIODO'], "d/m/Y H:i:s")->format('d/m/Y');
                $rowMes['FINAL']             = DateUtil::getDataDeString($mapa['DTFIMPERIODO'], "d/m/Y H:i:s")->format('d/m/Y');

                $notasMes = $this->factory->getNotasFiscalVendedor($rowMes);
                $rowMes['NRMAPACOMIS']       = $mapa['NRMAPACOMIS'];
                $notasMapaComExp = $this->factory->getNotasForaPeriodo($rowMes);

                if($notasMes) {
                    $contador = 0;
                    foreach ($notasMes as $value) {
                        $notasMes[$contador] = $value['NRLANCTONF'].'/'.$value['VRNOTAFISC'];
                        $contador++;
                    }
                }
                if($notasMapaComExp) {
                    $contador = 0;
                    foreach ($notasMapaComExp as $value) {
                        $notasMapaComExp[$contador] = $value['NRLANCTONF'].'/'.$value['VRNOTAFISC'];
                        $contador++;
                    }
                }
                $notasNaoApuradas = array_diff($notasMes, $notasMapaComExp);
                $contador = 0;
                foreach ($notasNaoApuradas as $value) {
                    $explodevalue = explode('/', $value);
                    $nrlanctonf = $explodevalue[0];
                    $vrnota = $explodevalue[1];
                    $notasMapasAnteriores[$contador]['NRLANCTONF']    = $nrlanctonf;
                    $notasMapasAnteriores[$contador]['VRNOTAFISC']    = $vrnota;
                    $notasMapasAnteriores[$contador]['CDVENDEDOR']    = $row['VENDEDOR'];
                    $notasMapasAnteriores[$contador]['DSERROMAPAEXP'] = "Essa nota não pertence à este periodo";
                    $contador++;
                }

            }
        }

        // Busca as Notas Ficais do vendedor naquele periodo
        $result = $this->factory->getNotasFiscalVendedor($row);
        if($notasMapasAnteriores) $result = array_merge($result, $notasMapasAnteriores);

        // Verifica se o usuario deseja excluir as notas fora do periodo
        if($row['excluiForaPeriodo'] === 'N') {
            // Busca as notas fora do periodo
            $notasForaPeriodo = $this->factory->getNotasForaPeriodo($row);
            // Adiciona as notas fora do periodo ao array de notas no periodo
            if($notasForaPeriodo) {
                foreach ($notasForaPeriodo as $nota) {
                    $nota['__is_new'] = false;
                    array_push($result, $nota);
                }
            }
        }

        // Inicializa variaveis
        $rowGetValores = $row;
        $count = 0;
        $ValorTotalComissao = 0;

        // Percorre o vetor de notas colocando cada valor em $value
        foreach($result as $value) {
            $rowGetValores['NRLANCTONF'] = $value['NRLANCTONF'];
            // Atraves do metodo getRowToSaveNota calcula os valores referentes a nota
            $value = $this->getRowToSaveNota($value, $rowGetValores);
            // Verifica se a nota já foi inserida em outro periodo
            if($value['OUTROPERIODO'] === 'N') {
                $result[$count] = $value;
                $ValorTotalComissao += $value['VRCOMISSAO'];
            }
            else {
                // Caso a nota faça parte de outro periodo ela é retirada do vetor de notas
                unset($result[$count]);
            }
            $count++;
        }
        return $result;
    }

    public function getRowToSaveNota($value, $row) {
        $notaOutroPeriodo = null;
        
        /*if(isset($value['EDITCOMISSAO'])) {
            if($value['EDITCOMISSAO'] !== true) {
                $notaOutroPeriodo = $this->factory->verificaNotaOutroPeriodo($row, $value);
            }
        }
        else {
            $notaOutroPeriodo = $this->factory->verificaNotaOutroPeriodo($row, $value);
        }
        
        if(!($notaOutroPeriodo)) {
            
            if($row['VRPERCOMEXP'] > 0) {
                $value = $this->calculaValoresNota($value, $row);
            }
            else {
                $value['VRBASECOMIS']   =  0 ;
                
                $value['VRCOMISSAO']    =  0 ;
                $value['IDVRAPURADO']   = 'S';
                if(!(isset($value['DSERROMAPAEXP']))) {
                    $value['DSERROMAPAEXP']= null;
                }
            }*/
            if(isset($value['__is_new'])) {
                if(empty($value['__is_new']) && $value['__is_new'] !== false) {
                    $cdContador = 'MAPACOMEXP'.$row['NRMAPACOMIS'].$row['VENDEDOR'].$row['CDFILIAL'];
                    $value['NRMAPACOMEXP'] = $this->newCode->getCodeByTableName($cdContador, $row['NRORG'], 1, 10);
                    $value['__is_new'] = true;
                }
            }
            else {
                $cdContador = 'MAPACOMEXP'.$row['NRMAPACOMIS'].$row['VENDEDOR'].$row['CDFILIAL'];
                $value['NRMAPACOMEXP'] = $this->newCode->getCodeByTableName($cdContador, $row['NRORG'], 1, 10);
                $value['__is_new'] = true;
            }
            $value['CDFILICOMIS']   = $row['CDFILIAL'];
            $value['NRORG']         = $row['NRORG'];
            $value['NRMAPACOMIS']   = $row['NRMAPACOMIS'];
            $value['OUTROPERIODO']  = 'N';
            $value['CDVENDEDOR']    = $row['VENDEDOR'];
            $value['IDVRAPURADO']   = 'N';
        
            // $value['NREXPEDICAO']   = $value['NREXPEDICAO'];
            // $value['VRNOTAFISC']    = $value['VRNOTAFISC'];
            // $value['VRBASE']        = $value['VRBASE'];
            // $value['VRCOMISSAO']    = $value['VRCOMISSAO'];
            // ParamByName('CDVENDEDOR' )      := P_CDVENDEDOR;              ok
            // ParamByName('CDFILICOMIS' )     := P_CDFILIAL;               ok
            // ParamByName('NRMAPACOMIS' )     := P_NRMAPACOMIS;            ok
            // ParamByName('CDFILIAL' )        := adqApuraNotasCDFILIAL;    ok
            // ParamByName('NRMAPACOMEXP' )    := stNrMapaComExp;           ok
            // ParamByName('NRLANCTONF' )      := adqApuraNotasNRLANCTONF;   ok
            // ParamByName('NREXPEDICAO' )     := adqApuraNotasNREXPEDICAO; ok
            // ParamByName('VRNOTAFISC' )      := adqApuraNotasVRNOTAFISC;  ok
            // ParamByName('VRBASECOMIS' )     := doVrBase;
            // ParamByName('VRCOMISSAO' )      := doVrComissao;
            // ParamByName('IDVRAPURADO' )     := stVrApurado;
            // ParamByName('DSERROMAPAEXP')    := stMens;*/
            
        return $value;
    }

    public function getRowsToSaveContas($row) {
        $contasMapasAnteriores = array();
       
        $mapasAnteriores = $this->factory->getMapasAnteriores($row);
        
        if($mapasAnteriores) {
            foreach ($mapasAnteriores as $mapa) {
                $rowMes['NRORG']        = $row['NRORG'];
                $rowMes['VENDEDOR']     = $row['VENDEDOR'];
                $rowMes['CDFILIAL']     = $row['CDFILIAL'];
                $rowMes['INICIAL']      = DateUtil::getDataDeString($mapa['DTINIPERIODO'], "d/m/Y H:i:s")->format('d/m/Y');
                $rowMes['FINAL']        = DateUtil::getDataDeString($mapa['DTFIMPERIODO'], "d/m/Y H:i:s")->format('d/m/Y');
                
                $contasMes                   = $this->factory->getContasVendedor($rowMes);
                $rowMes['NRMAPACOMIS']       = $mapa['NRMAPACOMIS'];
                $contasMapaComRec = $this->factory->getContasForaPeriodo($rowMes);
                
                if($contasMes) {
                    $contador = 0;
                    foreach ($contasMes as $value) {
                        $contasMes[$contador] = $value['NRLANCTONF'].'/'.$value['VRATUAREC'].'/'.$value['NRSEQVENREC'].'/'.$value['NRPARCELAREC'];
                        $contador++;
                    }
                }
                if($contasMapaComRec) {
                    $contador = 0;
                    foreach ($contasMapaComRec as $value) {
                        $contasMapaComRec[$contador] = $value['NRLANCTONF'].'/'.$value['VRATUAREC'].'/'.$value['NRSEQVENREC'].'/'.$value['NRPARCELAREC'];
                        $contador++;
                    }
                }
                $contasNaoApuradas = array_diff($contasMes, $contasMapaComRec);
                foreach ($contasNaoApuradas as $value) {
                    $explodevalue   = explode('/', $value);
                    $nrlanctonf     = $explodevalue[0];
                    $vrconta        = $explodevalue[1];
                    $nrseqvenrec    = $explodevalue[2];
                    $nrparcelarec   = $explodevalue[3];
                    $contasMapasAnteriores[$contador]['VRATUAREC']     = $vrconta;
                    $contasMapasAnteriores[$contador]['NRLANCTONF']    = $nrlanctonf;  
                    $contasMapasAnteriores[$contador]['NRSEQVENREC']   = $nrseqvenrec;
                    $contasMapasAnteriores[$contador]['NRPARCELAREC']  = $nrparcelarec;
                    $contasMapasAnteriores[$contador]['CDVENDEDOR']    = $row['VENDEDOR'];
                    $contasMapasAnteriores[$contador]['DSERROMAPAEXP'] = "Essa conta não pertence à este periodo";
                    $contador++;
                }
            }
            
        }
        
        $result = $this->factory->getContasVendedor($row);
        if($contasMapasAnteriores) $result = array_merge($result, $contasMapasAnteriores);
        
        if($row['excluiForaPeriodo'] === 'N') {
            $contasForaPeriodo = $this->factory->getContasForaPeriodo($row);
            if($contasForaPeriodo) {
                foreach ($contasForaPeriodo as $conta) {
                    $conta['__is_new'] = false;
                    array_push($result, $conta);
                }
            }
        }
        
        $rowGetValores = $row;
        $count = 0;
        foreach ($result as $value) {
                
            $rowGetValores['NRLANCTONF'] = $value ['NRLANCTONF'];
            $rowGetValores['NRSEQVENREC'] = $value ['NRSEQVENREC'];
            $value = $this->getRowToSaveConta($value, $rowGetValores);
            
            if ($value['OUTROPERIODO'] === 'N') {
                $result[$count] = $value;
            }
            else {
                unset($result[$count]);
            }
            $count ++;
        }
        
        return $result;
    }

    public function getRowToSaveConta($value, $row) {
        $contaOutroPeriodo = null;
       

        /*if(isset($row['EDITCOMISSAO'])) {
            if($row['EDITCOMISSAO'] !== true) {
                 $contaOutroPeriodo = $this->factory->verificaContaOutroPeriodo($row, $value);
            }
        }
        else  {
            $contaOutroPeriodo = $this->factory->verificaContaOutroPeriodo($row, $value);
        }*/
        
        // if (!($contaOutroPeriodo)) {
            
            /*if($row['VRPERCOMREC'] > 0) {
                $value = $this->calculaValoresConta($value, $row);
            }
            else {
                $value['VRACREENCARGO'] =  0 ;
                $value['VRBASECOMIS']   =  0 ;
                $value['VRCOMISSAO']    =  0 ;
                $value['IDVRAPURADO']   = 'S';
                if(!(isset($value['DSERROMAPAREC']))) {
                    $value['DSERROMAPAREC']= null;
                }
            }*/
            if(isset($value['__is_new'])) {
                if(empty($value['__is_new']) && $value['__is_new'] !== false) {
                    $cdContador                 = 'MAPACOMREC'.$row['NRMAPACOMIS'].$row['VENDEDOR'].$row['CDFILIAL'];
                    $value['NRMAPACOMREC']      = $this->newCode->getCodeByTableName($cdContador, $row['NRORG'], 1, 10);
                    $value['__is_new']          = true;
                }
            }
            else {
                $cdContador                 = 'MAPACOMREC'.$row['NRMAPACOMIS'].$row['VENDEDOR'].$row['CDFILIAL'];
                $value['NRMAPACOMREC']      = $this->newCode->getCodeByTableName($cdContador, $row['NRORG'], 1, 10);
                $value['__is_new']          = true;
            }
            $value['NRORG']             = $row['NRORG'];
            $value['CDFILICOMIS']       = $row['CDFILIAL'];
            $value['NRMAPACOMIS']       = $row['NRMAPACOMIS'];
            $value['CDVENDEDOR']        = $row['VENDEDOR'];
            $value['OUTROPERIODO']      = 'N';
            
            $paramsExp = $this->factory->getParexpedicao($value);
            
            if ($paramsExp[0]['IDICMSCOMISS'] == 'S')
                $vrComissao = $value['VRCOMISRECST'];
            else
                $vrComissao = $value['VRCOMISREC'];
            
            $value['VRCOMISSAO']    = $vrComissao;
            $value['VRBASECOMIS']   = $value['VRBASE'];
            $value['DSERROMAPAREC'] = '';
            $value['VRACRENCARGO']  = 0;
            $value['IDVRAPURADO']   = 'N';
          
            
        return $value;
    }

    public function getPoliticaFilial($row) {
        $politicaFilial = $this->factory->getPoliticaFilial($row);
        $row['VRPERCOMREC']    = $politicaFilial[0]['VRPERCOMREC'];
        $row['VRPERCOMEXP']    = $politicaFilial[0]['VRPERCOMEXP'];
        $row['IDENCARPRIPARC'] = $politicaFilial[0]['IDENCARPRIPARC'];
        return $row;
    }
   
    public function getProdutosNotaFiscal($row) {
        $result = $this->factory->getProdutosNotaFiscal($row);
        $count = 0;
        foreach($result as $item) {
                
            $item['valorMenosDesconto'] = ($item['IPQTITEMPROD']  * $item['VRUNITITEM']) - $item['VRDESCITEM'];
    
            $item['VRPROD']     = ($item['IPQTITEMPROD']  * $item['VRUNITITEM']) - $item['VRDESCITEM'];
            
            $item['VRDESONERA'] = $this->NVL($item['VRIMPOSTOIT']);
            
            $item['VRENCARGO']  = round($this->NVL($item['VRITEMENCA']*($item['VRTOTAITEM'] - $item['VRDESCITEM'])),2);
            
            $item['VRBASE']     = round($item['valorMenosDesconto'] - ($this->NVL($item['VRIMPOSTOIT']))
                    -round(($this->NVL($item['VRITEMENCA']* (
                   $item['VRTOTAITEM'] - $item['VRDESCITEM'])/$item['VRPRODUTOS'])),2),2);
            
            $item['VRCOMISSAO'] = ($item['VRPECOMITPED']*($item['valorMenosDesconto'] -
                    ($this->NVL($item['VRIMPOSTOIT']) - round($this->NVL((($item['VRITEMENCA']*
                    ($item['VRTOTAITEM']-$item['VRDESCITEM'])/
                    $item['VRPRODUTOS']))),2)))*0.01);
                    
            $result[$count] = $item;        
            $count++;
        }
        return $result;
    
    }
    
    public function deleteMapas($row) {
        $this->factory->deleteMapas($row);
    }
    
    public function verificaAlertaMapas($row) {
      
        $rowReturn = $this->factory->verificaAlertaMapas($row);
        if($rowReturn) {
            $rowReturn = array(
                "ERRO" => true
            );
        }
        else {
            $rowReturn = array(
                "ERRO" => false
            );
        }
        
            
        return $rowReturn;
    }
    
    public function gerarContaPagar($row) {
        try {    
            $dadosFilial           = $this->factory->getDadosFilial($row)[0];
            $fornecedor            = $this->factory->getFornecedor($row);
            if (!(isset($fornecedor[0]))){
                throw new \Exception('Vendedor não relacionado a um fornecedor.');
            } else {
                $fornecedor = $fornecedor[0];
            }
            $politicaFilial        = $this->factory->getPoliticaFilial($row)[0];
            $row['CDVENDEDOR']     = $row['VENDEDOR'];
            $row['CDEMPRESA']      = $dadosFilial['CDEMPRESA'];
            $row['CDFORNECED']     = $fornecedor['CDFORNECED'];
            $row['DSCONTAPAG']     = 'Mapa de Comissão '. $row['NRMAPACOMIS'];
            $row['NRPARCPGTOFO']   = $fornecedor['NRPARCPGTOFO'];
            $row['VRCONTAPARC']    = $row['VRCONTAPAG'];
            $row['CDSERIE']        = $dadosFilial['CDSERIE'];
            $row['CDOPERACTPG']    = $this->environment->getCdOperador();
            $row['NRSEQVENPAG']    = '';
            $row['DTLIBERACAOFIN'] = date('d/m/Y'); 
            $row['DTCONTAPAG']     = date('d/m/Y');
            $cdCountBoleto         = 'BOLETPAGAR'.$row['CDFILIAL'];
            $cdCountNota           = 'LANCNF/FILIAL'.$row['CDFILIAL'];
            $cdCountNrNota         = 'NRNOTA/FILIAL'.$row['CDFILIAL'];
            $row['NRLANBOLPAG']    = $this->newCode->getCodeByTableName($cdCountBoleto, $row['NRORG'], 1, 10);
            $row['NRLANCTONF' ]    = $this->newCode->getCodeByTableName($cdCountNota,   $row['NRORG'], 1, 10);
            
            // NRNOTAFISC é digitado pelo usuario na tela de lançamento de entrada
            // Então é necessario verificar se o código gerado pelo newCode já existe
            $codigoNota = $this->newCode->getCodeByTableName($cdCountNrNota, $row['NRORG'], 1, 10);
            $params = array("NRORG"    => $row['NRORG'],
                            "CDFILIAL" => $row['CDFILIAL']);
            $codigoValido = false;
            while($codigoValido === false) {
                $params['NRNOTAFISC'] = $codigoNota;
                $result = $this->factory->verificaCodigoNota($params);
                if (isset($result[0])) {
                    $codigoNota = $this->newCode->getCodeByTableName($cdCountNrNota, $row['NRORG'], 1, 10);
                } else {
                    $row['NRNOTAFISC'] = $codigoNota;
                    $codigoValido = true;
                }
            }
            
            // var_dump(isset($fornecedor[0]));
            $verificaCDTPCTPAGAR = $this->factory->verificaCDTPCTPAGAR($row);
            if(!($verificaCDTPCTPAGAR[0]['CDTPCTPAGAR'])){
                throw new \Exception("Fornecedor não possui tipo de conta cadastrada.");
            }
            
            $this->factory->gerarContaPagar($row);
            $contasPagar = $this->factory->getContasPagar($row);
            
            
            $i = 0;
            foreach($contasPagar as $conta) {
                $conta['CDVENDEDOR'] = $row['CDVENDEDOR'];
                // ParamByName('CDVENDEDOR' ).AsString := P_CDVENDEDOR;
                
                $conta['NRMAPACOMIS'] = $row['NRMAPACOMIS'];
                // ParamByName('NRMAPACOMIS' ).AsString := P_NRMAPACOMIS;
                
                $conta['CDFILICOMIS'] = $conta['CDFILIAL'];
                // ParamByName('CDFILICOMIS' ).AsString := P_CDFILICOMIS; ParamByName('CDFILIAL' ).AsString := adqVdContaPagCDFILIAL.AsString;
                
                $cdCountComPag = $row['VENDEDOR'].$conta['CDFILICOMIS'].$row['NRMAPACOMIS'];
                $conta['NRMAPACOMPAG' ]   = $this->newCode->getCodeByTableName($cdCountComPag,   $row['NRORG'], 1, 10);
                // ParamByName('NRMAPACOMPAG').AsString := stNrMapaComPag;
                
                $conta['__is_new'] = true;
                $contasPagar[$i] = $conta;
                $i++;
                
                // ParamByName('NRLANCTONF' ).AsString := adqVdContaPagNRLANCTONF.AsString;
                // ParamByName('NRSEQVENPAG' ).AsString := adqVdContaPagNRSEQVENPAG.AsString;
                // ParamByName('NRPARCELAPAG').AsString := adqVdContaPagNRPARCELAPAG.AsString;
                
                // ParamByName('NRLANCCONT' ).AsString := stLancProc; vai ser adicionado aqui 
            }
            
            return $contasPagar; 
        } catch (\Exception $e) {
            throw $e;
        }
        
    }
    
    public function getContasNota($row) {
        return $this->factory->getContasNota($row);
    }
    
    public function getNotasReapurar($row) {
        $notasReapurar = $this->factory->getNotaVendItem($row);
        foreach ($notasReapurar as $nota) {
            $row['NRLANCTONF']  = $nota['NRLANCTONF'];
            $verificaContaPagar = $this->factory->verificaContaPagarMapa($row);;
            if(isset($verificaContaPagar[0])) {
                return false;
            }
            else {
                return $notasReapurar;
            }
        }
    }
    
    public function getNRMAPACOMEXP($row) {
        return $this->factory->getNRMAPACOMEXP($row);
    }
    public function getNRMAPACOMREC($row) {
        return $this->factory->getNRMAPACOMREC($row);
    }
    
    //-----------------------------------------------------------------------------//

    protected function calculaValoresNota($value, $row) {

       $result = $this->factory->getValoresNota($row);
       $ValorBase = 0;
       $ValorComissao = 0;
       $ValorComissaoExp = 0;
       $Apurado = 'S';

       foreach ($result as $item) {
           if(!($item['VRPECOMITPED']))  $Apurado = 'N';
           $valorMenosDesconto = ($item['QTITEMPROD']  * $item['VRUNITITEM']) - $item['VRDESCITEM'];


           $ValorBase += $valorMenosDesconto - ($this->NVL($item['VRIMPOSTOIT']))
                -round(($this->NVL($item['VRITEMENCA']* (
               $item['VRTOTAITEM'] - $item['VRDESCITEM'])/$item['VRPRODUTOS'])),2);

            $ValorComissao += ($item['VRPECOMITPED']*($valorMenosDesconto -
                ($this->NVL($item['VRIMPOSTOIT']) - round($this->NVL((($item['VRITEMENCA']*
                ($item['VRTOTAITEM']-$item['VRDESCITEM'])/
                $item['VRPRODUTOS']))),2)))*0.01);


            $ValorComissaoExp += ($item['VRPERCOMEXP'] * ($item['VRPECOMITPED'] *
                ($valorMenosDesconto - $this->NVL($item['VRIMPOSTOIT']))
                - round($this->NVL(($item['VRITEMENCA']*($item['VRTOTAITEM'] - $item['VRDESCITEM'])/$item['VRPRODUTOS'])
                ),2)*0.01)*0.01)*0.01;
       }


       $value['VRBASECOMIS']     = $ValorBase;
       $value['VRCOMISSAO']      = $ValorComissaoExp;
      
       $value['IDVRAPURADO']     = $Apurado;
       if($Apurado === 'N') {
            $value['DSERROMAPAEXP']   = "A nota possui itens sem valor de comissão!"; 
        }
        else if(isset($value['DSERROMAPAEXP'])) {
            if($value['DSERROMAPAEXP'] === "A nota possui itens sem valor de comissão!") {
                $value['DSERROMAPAEXP'] = null;
            }
        }
        else {
            $value['DSERROMAPAEXP'] = null;
        }
       
       return $value;
    }

    protected function calculaValoresConta($value, $row) {
        $row['NRSEQVENREC'] = $value['NRSEQVENREC'];
        $result = $this->factory->getValoresContas($row);
        $VRRATEIAENC        = 0;
        $VRBASETOT          = 0;
        $VRCOMISSAO         = 0;
        $VRCOMISTOT         = 0;
        $ValorBase          = 0;
        $ValorComisRec      = 0;
        $ValorBaseEncargo   = 0;
        $ValorComisEncargo  = 0;
        $Boolean            = false;
        $Apurado            = 'S';
        foreach ($result as $item) {
            
            if(!$item['VRPECOMITPED']) $Apurado = 'N';
            $valorMenosDesconto = ($item['QTITEMPROD']  * $item['VRUNITITEM']) - $item['VRDESCITEM'];

            $VRRATEIAENC += (round($this->NVL(($this->NVL($item['EAVRITEMENCA'], 1))*
                ($item['VRTOTAITEM'] - $item['VRDESCITEM'])/$item['VRPRODUTOS']),2)*0.01);

            $ValorBaseEncargo += ($valorMenosDesconto - $this->NVL($item['VRIMPOSTOIT']) -
                            round($this->NVL(($item['EDVRITEMENCA']*($item['VRTOTAITEM']-$item['VRDESCITEM'])/$item['VRPRODUTOS'])),2));


            $ValorComisEncargo += ($item['VRPERCOMREC']*($item['VRPECOMITPED']*($valorMenosDesconto - $this->NVL($item['VRIMPOSTOIT']) -
                            round($this->NVL($item['EDVRITEMENCA']*($item['VRTOTAITEM'] - $item['VRDESCITEM'])/$item['VRPRODUTOS']),2))*0.01)*0.01);

            $VRPERPARCELA  = (($value['VRATUAREC'] * 100) / $item['VRCONTA']);

            $VRBASETOT += $valorMenosDesconto - ($this->NVL($item['VRIMPOSTOIT']))
                        -round(($this->NVL($item['EDVRITEMENCA']* (
                       $item['VRTOTAITEM'] - $item['VRDESCITEM'])/$item['VRPRODUTOS'])),2);


            $VRCOMISSAO += ($item['VRPECOMITPED']*($valorMenosDesconto -
                    ($this->NVL($item['VRIMPOSTOIT']) - round($this->NVL((($item['EDVRITEMENCA']*
                    ($item['VRTOTAITEM']-$item['VRDESCITEM'])/
                    $item['VRPRODUTOS']))),2)))*0.01);


            $VRCOMISTOT += ($item['VRPERCOMREC']*($item['VRPECOMITPED']*($valorMenosDesconto -
                            $this->NVL($item['VRIMPOSTOIT'])
                            - round(($this->NVL($item['EDVRITEMENCA']*($item['VRTOTAITEM'] - $item['VRDESCITEM'])/$item['VRPRODUTOS']))
                            /2))*0.01)*0.01);



            $ValorBase += (($valorMenosDesconto - ($this->NVL($item['VRIMPOSTOIT']) - round(
                $this->NVL(($item['EDVRITEMENCA']*($item['VRTOTAITEM'] - $item['VRDESCITEM'])/$item['VRPRODUTOS'])),2)))*0.01);



            $ValorComisRec += ($item['VRPERCOMREC'] * ($item['VRPECOMITPED'] * ($valorMenosDesconto - ($this->NVL($item['VRIMPOSTOIT']))
           - round($this->NVL(($item['EDVRITEMENCA']*($item['VRTOTAITEM']-$item['VRDESCITEM'])/$item['VRPRODUTOS'])),2))*0.01)*0.01);




        }

        foreach ($result as $item) {

            if($item['CRDTATUAVENREC'] === $item['XCDTATUAVENREC']) {
                $value['VRENCACRESCE'] = $this->NVL($item['EAVRITEMENCA']);
                $value['VRBASEENC'] = (((($item['VRATUAREC'] - $this->NVL($item['EAVRITEMENCA']))*100) /
                    ($item['VRCONTA'] - $this->NVL($item['EAVRITEMENCA']))) * $ValorBaseEncargo)*0.01;

                $value['VRCOMISENC'] = (((($item['VRATUAREC'] - $this->NVL($item['EAVRITEMENCA']))*100) /
                    ($item['VRCONTA'] - $this->NVL($item['EAVRITEMENCA']))) * $ValorComisEncargo)*0.01;
            }
            else {
                $value['VRENCACRESCE'] = 0;
                $value['VRBASEENC'] = (((($item['VRATUAREC'])*100) /
                    ($item['VRCONTA'] - $this->NVL($item['EAVRITEMENCA']))) * $ValorBaseEncargo)*0.01;
                $value['VRCOMISENC'] = (((($item['VRATUAREC'])*100) /
                    ($item['VRCONTA'] - $this->NVL($item['EAVRITEMENCA']))) * $ValorComisEncargo)*0.01;

            }
        }

        $VRRATEIAENC          *= $VRPERPARCELA;
        $ValorBase            *= $VRPERPARCELA;
        $ValorComisRec        *= $VRPERPARCELA;
        $ValorComisRec        *= 0.01;


        if($row['IDENCARPRIPARC'] === 'S') {
            if($value['NRSEQVENREC'] === '01') {
                $value['VRBASECOMIS']   = $value['VRBASEENC'];
                $value['VRCOMISSAO']    = $value['VRCOMISENC'];
                $value['VRACREENCARGO'] = $value['VRENCACRESCE'];

            }
            else {
                $value['VRBASECOMIS']   = $value['VRBASEENC'];
                $value['VRCOMISSAO']    = $value['VRCOMISENC'];
                $value['VRACREENCARGO'] = 0;

            }
        }

        else {
            $value['VRBASECOMIS']   = $ValorBase;
            $value['VRCOMISSAO']    = $ValorComisRec;
            $value['VRACREENCARGO'] = $VRRATEIAENC;
        }
        $value['IDVRAPURADO']     = $Apurado;
        if($Apurado === 'N') {
            $value['DSERROMAPAREC']   = "A conta possui itens sem valor de comissão!"; 
        }
        else if(isset($value['DSERROMAPAREC'])) {
            if($value['DSERROMAPAREC'] === "A conta possui itens sem valor de comissão!") {
                $value['DSERROMAPAREC'] = null;
            }
        }
        else {
            $value['DSERROMAPAREC'] = null;    
        }
        return $value;
    }

    protected function NVL($value, $a = 0) {
        if(!$value) return $a;
        else return $value;

    }
}

